from sparql_completer import SparqlCompleter, CompletionPos

from backend import dummy
from copy import deepcopy
import query_model
import eval_data

backend = dummy.DummyBackend("blubb", 25, "som_path", True)

templates = dict()

templates["predicate"] = """
%PREFIXES%
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
PREFIX skos: <http://www.w3.org/2004/02/skos/core#>
PREFIX wikibase: <http://wikiba.se/ontology#>
PREFIX schema: <http://schema.org/>
# IF CURRENT_SUBJECT_VARIABLE #  
SELECT ?qleverui_entity (SAMPLE(?name) as ?qleverui_name) (SAMPLE(?alias) as ?qleverui_altname) (SAMPLE(?count_1) as ?qleverui_count) WHERE {
# ELSE #
SELECT ?qleverui_entity (SAMPLE(?name) as ?qleverui_name) (SAMPLE(?alias) as ?qleverui_altname) (SAMPLE(?count_2) as ?qleverui_count) WHERE {
# ENDIF #
  { SELECT ?qleverui_entity (COUNT(?qleverui_entity) AS ?count_1) WHERE {
    %CONNECTED_TRIPLES% %CURRENT_SUBJECT% ql:has-predicate ?qleverui_entity .
  } GROUP BY ?qleverui_entity }
  { SELECT ?qleverui_entity ?name ?alias ?count_2 WHERE {
      { { SELECT ?qleverui_entity (COUNT(?qleverui_entity) AS ?count_2) WHERE { ?x ql:has-predicate ?qleverui_entity } GROUP BY ?qleverui_entity }
        ?entity ?tmp ?qleverui_entity . ?entity rdfs:label ?name . ?entity rdfs:label|skos:altLabel ?alias }
      UNION
      { { SELECT ?qleverui_entity (COUNT(?qleverui_entity) AS ?count_2) WHERE { ?x ql:has-predicate ?qleverui_entity } GROUP BY ?qleverui_entity }
        VALUES (?qleverui_entity ?name ?alias) {
          (rdfs:label rdfs:label rdfs:label)
	  (skos:altLabel skos:altLabel skos:altLabel)
          (schema:description schema:description schema:description)
	  (wikibase:sitelinks wikibase:sitelinks wikibase:sitelinks)
  } } } ORDER BY ?alias }
  # IF !CURRENT_WORD_EMPTY #
  FILTER regex(?alias, "%CURRENT_WORD%") 
  # ENDIF #
} GROUP BY ?qleverui_entity ORDER BY DESC(?qleverui_count)
"""

import sys
comp = SparqlCompleter(templates, dict(), sys.stdout, sys.stdout, False, backend)

orig_query = query_model.parse_sparql("SELECT ?a WHERE {?x <y> ?z}")
named_query = eval_data.NamedQuery(orig_query)
orig_query = orig_query.where
completion_pattern = deepcopy(orig_query)
completion_pattern[0] = [completion_pattern[0][0], '□','□']

comp._complete_predicate(completion_pattern, orig_query, CompletionPos(0, 1), dict())
