#!/usr/bin/env python3

from query_model import parse_sparql
from query_model import qlever_hacks

query = """

"""
query = """ 
  SELECT ?x WHERE {
  ?x ?y ?z
  } """


#print(parse_sparql(query))
query = """ 
  SELECT ?x WHERE {
  ?x ^<a> ?z
  } """
print(parse_sparql(query, True))
query = """
   PREFIX wd: <http://www.wikidata.org/entity/>
    PREFIX wdt: <http://www.wikidata.org/prop/direct/>
    SELECT DISTINCT ?item WHERE {
      ?item wdt:P31 wd:Q5 ;
      wdt:P106/wdt:P279* wd:Q482980 .
      # Removed FILTER
    }
"""
res = parse_sparql(query, True)
print(res)

query = """
PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
PREFIX skos: <http://www.w3.org/2004/02/skos/core#>
PREFIX schema: <http://schema.org/>
PREFIX wikibase: <http://wikiba.se/ontology#>
PREFIX wdt: <http://www.wikidata.org/prop/direct/>
SELECT ?qleverui_entity (SAMPLE(?name) AS ?qleverui_name) (SAMPLE(?alias) AS ?qleverui_altname) (SAMPLE(?count) AS ?qleverui_count) WHERE {
  { SELECT ?qleverui_entity ?name ?alias ?count WHERE {
    ?qleverui_entity rdfs:label ?name . FILTER (lang(?name) = "en") .
    ?qleverui_entity rdfs:label|skos:altLabel ?alias . FILTER (lang(?alias) = "en") .
    ?qleverui_entity ^schema:about/wikibase:sitelinks ?count .
  } ORDER BY ?alias }
} GROUP BY ?qleverui_entity ORDER BY DESC(?qleverui_count)
"""

res = parse_sparql(query, True)
print(res)

query = """
SELECT ?x WHERE {
  ?x a:b/a:c* ?c
}
"""
query = """
    PREFIX wd: <http://www.wikidata.org/entity/>
    PREFIX wdt: <http://www.wikidata.org/prop/direct/>
    PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
    SELECT ?city ?cityLabel ?population ?OSM_relation_ID WHERE {
      VALUES ?town_or_city {
        wd:Q3957
        wd:Q515
      }
      ?city wdt:P31/wdt:P279* ?town_or_city;
        wdt:P17 wd:Q35.
      OPTIONAL { ?city wdt:P1082 ?population. }
      OPTIONAL { ?city wdt:P402 ?OSM_relation_ID. }
      ?city rdfs:label ?cityLabel . FILTER (LANG(?cityLabel) = "en") .
    }
    LIMIT 100
"""

query = """
  PREFIX schema: <http://schema.org/>
  PREFIX wikibase: <http://wikiba.se/ontology#>
  PREFIX wikibase: <http://wikiba.se/ontology#>
  PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
  PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
  PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
  PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>
  PREFIX skos: <http://www.w3.org/2004/02/skos/core#>
  PREFIX wd: <http://www.wikidata.org/entity/>
  PREFIX wd: <http://www.wikidata.org/entity/>
  PREFIX p: <http://www.wikidata.org/prop/>
  PREFIX p: <http://www.wikidata.org/prop/>
  PREFIX wdt: <http://www.wikidata.org/prop/direct/>
  PREFIX wdt: <http://www.wikidata.org/prop/direct/>
  PREFIX psv: <http://www.wikidata.org/prop/statement/value/>

  SELECT ?entity (SAMPLE(?count_2) AS ?count) (SAMPLE(?name) AS ?name) (SAMPLE(?alias) AS ?alias) WHERE {
   {
    SELECT ?entity (COUNT(?entity) AS ?count_2) WHERE {
     ?item wdt:P131+ wd:Q1492 .
     ?item wdt:P31/wdt:P279* ?entity .
    }
    GROUP BY ?entity
    ORDER BY ?entity
   }
   {
    SELECT ?entity ?count ?name ?alias WHERE {
     ?entity rdfs:label ?name .
     FILTER (lang(?name)="en") .
     ?entity rdfs:label|skos:altLabel ?alias .
     FILTER (lang(?alias)="en") .
     ?entity ^schema:about/wikibase:sitelinks ?count .
    }
    ORDER BY ?entity
   }
  }
  GROUP BY ?entity
  ORDER BY DESC(?count)

"""

query = """
PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>
PREFIX skos: <http://www.w3.org/2004/02/skos/core#>
PREFIX wd: <http://www.wikidata.org/entity/>
PREFIX wd: <http://www.wikidata.org/entity/>
PREFIX p: <http://www.wikidata.org/prop/>
PREFIX wdt: <http://www.wikidata.org/prop/direct/>
PREFIX wdt: <http://www.wikidata.org/prop/direct/>

SELECT ?entity (SAMPLE(?count_2) AS ?count) (SAMPLE(?name) AS ?name) (SAMPLE(?alias) AS ?alias) WHERE {
 {
  SELECT ?entity (COUNT(?entity) AS ?count_2) WHERE {
   ?u wdt:P31/wdt:P279* wd:Q3918 .
   ?u wdt:P131+ ?state .
   ?u wdt:P571 ?founded .
   ?state ql:has-predicate ?entity .
  }
  GROUP BY ?entity
  ORDER BY ?entity
 }
 {
  SELECT ?entity ?count ?name ?alias WHERE {
   {
    {
     SELECT ?entity (COUNT(?entity) AS ?count) WHERE {
      ?x ql:has-predicate ?entity .
     }
     GROUP BY ?entity
    }
    ?m ?m_pred ?entity .
    ?m rdfs:label ?name .
    FILTER (lang(?name)="en") .
    ?m rdfs:label|skos:altLabel ?alias .
    FILTER (lang(?alias)="en") .
   } UNION {
    {
     SELECT ?entity (COUNT(?entity) AS ?count) WHERE {
      ?x ql:has-predicate ?entity .
     }
     GROUP BY ?entity
    }
    VALUES (?entity ?name ?alias){(rdf:type rdf:type rdf:type) (rdfs:label rdfs:label rdfs:label) (skos:altLabel skos:altLabel skos:altLabel) (schema:about schema:about schema:about) (schema:description schema:description schema:description) (wikibase:sitelinks wikibase:sitelinks wikibase:sitelinks)}   }
  }
  ORDER BY ?alias
 }
}
GROUP BY ?entity
ORDER BY DESC(?count)

"""
query = """
PREFIX schema: <http://schema.org/>
PREFIX wikibase: <http://wikiba.se/ontology#>
PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>
PREFIX skos: <http://www.w3.org/2004/02/skos/core#>
PREFIX wd: <http://www.wikidata.org/entity/>
PREFIX wd: <http://www.wikidata.org/entity/>
PREFIX p: <http://www.wikidata.org/prop/>
PREFIX wdt: <http://www.wikidata.org/prop/direct/>
PREFIX wdt: <http://www.wikidata.org/prop/direct/>

  SELECT ?entity (COUNT(?entity) AS ?count_2) WHERE {
   ?state wdt:P2852 ?emergencyNumber .
   OPTIONAL {
     ?state wdt:P1082 ?pop .
    }
   ?state wdt:P31/wdt:P279* ?entity .
  }
  GROUP BY ?entity
  ORDER BY ?entity
"""

query = """
PREFIX schema: <http://schema.org/>
PREFIX wikibase: <http://wikiba.se/ontology#>
PREFIX wikibase: <http://wikiba.se/ontology#>
PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>
PREFIX skos: <http://www.w3.org/2004/02/skos/core#>
PREFIX wd: <http://www.wikidata.org/entity/>
PREFIX wd: <http://www.wikidata.org/entity/>
PREFIX p: <http://www.wikidata.org/prop/>
PREFIX p: <http://www.wikidata.org/prop/>
PREFIX wdt: <http://www.wikidata.org/prop/direct/>
PREFIX wdt: <http://www.wikidata.org/prop/direct/>
PREFIX psv: <http://www.wikidata.org/prop/statement/value/>
SELECT ?entity (SAMPLE(?count_2) AS ?count) (SAMPLE(?name) AS ?name) (SAMPLE(?alias) AS ?alias) WHERE {
 {
  SELECT ?entity (COUNT(?entity) AS ?count_2) WHERE {
   ?item wdt:P131+ wd:Q1492 .
   ?item wdt:P31/wdt:P279* ?entity .
  }
  GROUP BY ?entity
  ORDER BY ?entity
 }
 {
  SELECT ?entity ?count ?name ?alias WHERE {
   ?entity rdfs:label ?name .
   FILTER (lang(?name)="en") .
   ?entity rdfs:label|skos:altLabel ?alias .
   FILTER (lang(?alias)="en") .
   ?entity ^schema:about/wikibase:sitelinks ?count .
  }
  ORDER BY ?entity
 }
}
GROUP BY ?entity
ORDER BY DESC(?count)"""

query = """
  SELECT ?item ?entity WHERE {
    ?item wdt:P32/wdt:P279* ?entity
  }
"""
query = """
    SELECT ?qlever_autocompl_entity (COUNT(?qlever_autocompl_entity) AS ?qlever_autocompl_count_2) WHERE {
     ?city (^wdt:P1082)*/^wdt:P31 ?population .
     ?lang ql:has-predicate ?qlever_autocompl_entity .
    }
"""

res = parse_sparql(query, True)
print(qlever_hacks.qlever_property_path_hack(res).to_sparql())
